import logging

from rest_framework import status

from api import constants
from api.models import Migration
from communication_handler.communication_handler import get_communication_handler
from dcmc_master_client.celery import app

logger = logging.getLogger(constants.CELERY_TASKS)


@app.task
def post_migration_status_to_itlb(vc_tag, migration_status):
    """Inform IT Load Balancer of migration status.

    This task sends a request to the migration endpoint of the Energy Aware IT
    Load Balancer in order to inform about the migration status. The essentials
    for the status update are the VC tag and the migration status.

    Parameters
    ----------
    vc_tag : str
        The VC tag as it has been generated by the VCG
    migration_status : {'pending', 'rejected', 'success', 'failed'}
        The updated status of the migration

    """
    task_tag = 'task:post_migration_status_to_itlb'
    logger.info('[{}][{}] Updating migration status on ITLB.'.format(task_tag, vc_tag))
    # Send migration request
    response = get_communication_handler().itlb.migration_update(vc_tag, migration_status)
    if response.status_code not in [status.HTTP_201_CREATED, status.HTTP_200_OK, status.HTTP_202_ACCEPTED]:
        logger.warning('[{}][{}] Update migration request has failed with status code [{}]. Aborting.'
                       .format(task_tag, vc_tag, response.status_code))
        return
    logger.info('[{}][{}] OK. Update of migration status on ITLB was successful.'.format(task_tag, vc_tag))


@app.task
def itlmc_register_migration_action(migration_id, data):
    """Inform ITLMC of a received migration request.

    This task sends a request to the IT Load Marketplace Connector in order to
    inform about a received migration request. It is utilized by the DCMC Master
    Clients of both source and destination DCs.

    Parameters
    ----------
    migration_id : int
        The id of the migration
    data : dict
        The data to send to the ITLMC. For more details check the ITLMConnectorClient class.

    """
    task_tag = 'task:itlmc_register_migration_action'
    migration_tag = 'Migration:{}'.format(migration_id)
    logger.info('[{}][{}] Registering migration to ITLMC'.format(task_tag, migration_tag))
    # Update data
    data.pop('vc_tag')
    load_values = data.pop('load_values')
    data.update({
        'loadvalues': load_values,
        'status': constants.PENDING,
        # TODO: Fix when value of energy is known
        'value': 0,
        'uom': 'kWh'
    })
    logger.debug('[{}][{}] Sending payload for registration: `{}`'
                 .format(task_tag, migration_tag, data))
    # Proceed to request
    response = get_communication_handler().itlmc.migration_action(migration_id, data)
    if response.status_code not in [status.HTTP_200_OK, status.HTTP_201_CREATED]:
        logger.warning('[{}][{}] Registration to the ITLMC has failed with response code [{}]'
                       .format(task_tag, migration_tag, response.status_code))
        migration = Migration.objects.select_related('load').get(id=migration_id)
        post_migration_status_to_itlb(migration.load.vc_tag, constants.FAILED)
    else:
        logger.info('[{}][{}] Registration to ITLMC was successful'.format(task_tag, migration_tag))


@app.task
def itlmc_register_migration_updates(marketaction, migration_status):
    """Inform ITLMC of migration status.

    This task sends a request to the IT Load Marketplace Connector in order to
    inform about the status of a migration. If the migration is delivered, this
    task is utilized by the DCMC Master Client of the source DC to inform about
    the migration delivery, otherwise the DCMC Master Clients of both the source
    and destination DCs might use this task to report migration failure.

    Parameters
    ----------
    marketaction : int
        The id of the market action related to the migration
    migration_status : {'delivered', 'not_delivered'}
        The current status of the requested migration

    """
    task_tag = 'task:itlmc_registered_migration_updates'
    marketaction_tag = 'Action:{}'.format(marketaction)
    logger.info('[{}][{}] Updating the migration status on ITLMC.'.format(task_tag, marketaction_tag))
    response = get_communication_handler().itlmc.register_migration_updates(marketaction, migration_status)
    if response.status_code != status.HTTP_200_OK:
        logger.warning('[{}][{}] Migration status update has failed with response code [{}].'
                       .format(task_tag, marketaction_tag, response.status_code))
        return
    logger.info('[{}][{}] Update of migration status succeeded.'.format(task_tag, marketaction_tag))
